org 7C00h

stack16_top:

USE16					; 16-bit code

loader_start:

	xor	ax,ax
; setup DS, ES segment registers
	mov	ds,ax
	mov	es,ax

	lss	sp,[new_stack_16]

; setup CS=0 and IP=new_IP
	jmp	far 0 : new_IP

align 4
new_stack_16:
	dw	stack16_top, 0

new_IP:

	sti

L0:
	mov	ah,00h
	int	16h

	cmp	ax,011Bh		; ESCAPE pressed
	jz	exit

	call	ascii2hex

	mov	dl,al

	mov	ah,00h
	int	16h

	cmp	ax,011Bh		; ESCAPE pressed
	jz	exit

	call	ascii2hex

	shl	dl,4
	or	al,dl

; PORT 0080 - MANUFACTURING DIAGNOSTICS PORT
; Note:	sometimes used for a POST hex display
; 
; 0080  -W  Manufacturing Diagnostics port

	out	80h,al
	jmp	L0

exit:
	mov	word [472h],1234h

	int	19h

	jmp	far 0FFFFh: 0000h


align 4
ascii2hex:
	or	al,20h		; convert uppercase to lowercase ('A'=41h to 'a'=61h, leave decimal numbers intact '0'=30h to '9'=39h)
	sub	al,'0'
	jc	ascii2hex_epi_wrong
	cmp	al,9
	jbe	ascii2hex_epi
	sub	al,'a'-'0'
	jc	ascii2hex_epi_wrong
	cmp	al,'f'-'a'
	jnbe	ascii2hex_epi_wrong
	add	al,10

ascii2hex_epi:

ascii2hex_epi_wrong:

	ret


times 512-2-$+loader_start	db 0

org 7DFEh
	dw	0AA55h
